#include <stdio.h>

#define FAST 1
#define SLOW 0

extern unsigned short fast_crc16(unsigned short sum,
                                 unsigned char const __code *p,
                                 unsigned long len);

extern unsigned short slow_crc16(unsigned short sum,
                                 unsigned char const __code *p,
                                 unsigned long len);

extern const __code unsigned short __checksum;
const __code unsigned int zero = 0;
#pragma segment="INTVEC" __code

void main(void)
{
     unsigned short sum=0;
#if FAST
     sum=fast_crc16(sum, (unsigned char const __code *)__segment_begin("INTVEC"), (unsigned long)&__checksum);
#else
#if SLOW
     sum=slow_crc16(sum, (unsigned char const __code *)__segment_begin("INTVEC"), (unsigned long)&__checksum);
     sum=slow_crc16(sum, (unsigned char const __code *)&zero, 2);
#endif
#endif

     if(sum!=__checksum)
          printf("Checksum failed: 0x%hx (counted) vs 0x%hx (from xlink)\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
